#include <iostream>
#include <string>
#include <SDL2/SDL.h>
#include <SDL2/SDL_surface.h>
#include <SDL2/SDL_render.h>

#define WINDOW_WIDTH 800
#define WINDOW_HEIGHT 600

//Key press surfaces constants 
enum KeyPressSurfaces { 
    KEY_PRESS_SURFACE_DEFAULT,
    KEY_PRESS_SURFACE_UP, 
    KEY_PRESS_SURFACE_DOWN, 
    KEY_PRESS_SURFACE_LEFT, 
    KEY_PRESS_SURFACE_RIGHT, 
    KEY_PRESS_SURFACE_TOTAL 
};

SDL_Texture* textures[KEY_PRESS_SURFACE_TOTAL];

std::string nomiFile[KEY_PRESS_SURFACE_TOTAL]={"hello_world.bmp", "up_image.bmp", "down_image.bmp", "left_image.bmp", "right_image.bmp"};

SDL_Texture* loadMedia(SDL_Renderer* ren)
{
	//Loading success flag
	SDL_Texture* tex = NULL;

	//Load splash image
	//The image we will load and show on the screen
    SDL_Surface* gHelloWorld = SDL_LoadBMP( "hello_world.bmp" );
	if( gHelloWorld == NULL )
	{
		printf( "Unable to load image %s! SDL Error: %s\n", "hello_world.bmp", SDL_GetError() );
        return tex;
    }

	tex = SDL_CreateTextureFromSurface(ren, gHelloWorld);
    //SDL_FreeSurface(gHelloWorld);
    if (tex == NULL){
        printf( "SDL_CreateTextureFromSurface Error: %s\n", SDL_GetError() );
    }
	
	return tex;
}

int main(int argc, char ** argv) {
  /* Declare window and renderer */
  SDL_Window * window;
  SDL_Renderer * renderer;
  SDL_Texture * tex;
  
  //Event handler
  SDL_Event event;
  
  /* Initialize SDL */
  SDL_Init(SDL_INIT_EVERYTHING);
  window = SDL_CreateWindow("SDLProva",
                            SDL_WINDOWPOS_CENTERED,
                            SDL_WINDOWPOS_CENTERED,
                            WINDOW_WIDTH, WINDOW_HEIGHT,
			    0);
  renderer = SDL_CreateRenderer(window, -1, SDL_RENDERER_ACCELERATED);
  tex = loadMedia(renderer);
  
  /* Main game loop */
  while (!SDL_QuitRequested()) {
            //Handle events on queue
        while( SDL_PollEvent( &event ) != 0 ) {
            //User requests quit
//             if( e.type == SDL_QUIT )
//             {
//                 quit = true;
//             }
        }

      
      
      SDL_RenderClear(renderer);
      SDL_RenderCopy(renderer, tex, NULL, NULL);
      
    /* Place your simulation code and rendering code here */
    SDL_RenderPresent(renderer);
  }

  /* Deinitialize everything */
  SDL_DestroyRenderer(renderer);
  SDL_DestroyWindow(window);
  SDL_Quit();

  return 0;
}
